<?php
/**
 * class LEAPIN_Breadcrumbs
 *
 * @author LeapIn Corp.
 * @since 1.0.0
 */
class LEAPIN_Breadcrumbs
{
    /**
     * Show breadcrumbs
     */
    public static function show()
    {
        // Settings
//        $separator = '<i class="material-icons">keyboard_arrow_right</i>';
        $separator = '/';
        $breadcrums_id = 'breadcrumbs';
        $breadcrums_class = 'breadcrumbs col-12';
        $home_title = 'Home';

        // If you have any custom post types with custom taxonomies, put the taxonomy name below (e.g. product_cat)
        $custom_taxonomy = 'product_cat';
        $content_num = 1;

        // Get the query & post information
        global $post, $wp_query;

        // Do not display on the homepage
        if (!(is_front_page() || is_home())) {

            // Build the breadcrums
            echo '<nav  id="' . $breadcrums_id . '" class="' . $breadcrums_class . '" aria-label="Breadcrumb navigation">';
            echo '<ol itemscope itemtype="http://schema.org/BreadcrumbList">';

            // Home page
            echo '<li class="item-home" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-link bread-home" href="' . leapin_get_home_url() . '" title="' . $home_title . '" itemprop="item"><span itemprop="name">' . $home_title . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';
            echo '<li class="separator separator-home" role="separator"> ' . $separator . ' </li>';

            if (is_archive() && is_tax() && !is_category() && !is_tag()) {

                // If post is a custom post type
                $post_type = get_post_type();

                // If it is a custom post type display name and link
                if ($post_type != 'post') {

                    $post_type_object = get_post_type_object($post_type);
                    $post_type_archive = get_post_type_archive_link($post_type);

                    echo '<li class="item-cat item-custom-post-type-' . $post_type . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-cat bread-custom-post-type-' . $post_type . '" href="' . $post_type_archive . '" title="' . $post_type_object->labels->name . '" itemprop="item"><span itemprop="name">' . $post_type_object->labels->name . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';
                    echo '<li class="separator" role="separator"> ' . $separator . ' </li>';

                }

                $query_obj = get_queried_object();
                $custom_tax_name = $query_obj->name;
                $get_term_slug = $query_obj->slug;
                $taxonomy = $query_obj->taxonomy;
                $get_term_link = get_term_link( $get_term_slug, $taxonomy );
                echo '<li class="item-current item-archive" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a href="'. $get_term_link .'" title="' . $custom_tax_name . '" class="bread-current bread-archive" itemprop="item"><span itemprop="name">' . $custom_tax_name . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';

            } else if (is_single()) {

                // If post is a custom post type
                $post_type = get_post_type();

                // If it is a custom post type display name and link
                if ($post_type != 'post') {

                    $post_type_object = get_post_type_object($post_type);
                    $post_type_archive = get_post_type_archive_link($post_type);

                    echo '<li class="item-cat item-custom-post-type-' . $post_type . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-cat bread-custom-post-type-' . $post_type . '" href="' . $post_type_archive . '" title="' . $post_type_object->labels->name . '" itemprop="item"><span itemprop="name">' . $post_type_object->labels->name . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';
                    echo '<li class="separator" role="separator"> ' . $separator . ' </li>';

                }

                // Get post category info
                $category = get_the_category();

                if (!empty($category)) {

                    // get category id
                    $term_id = leapin_get_yoast_primary_category_id();
                    if(!$term_id) return;
                    // Loop through parent categories and store in variable $cat_display
                    $cat_display = '';
                    foreach (self::get_cat_breadcrumbs_link_array($term_id, $content_num) as $cat_link) {
                        $cat_display .= '<li class="item-cat" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">' . $cat_link . '</li>';
                        $cat_display .= '<li class="separator" role="separator"> ' . $separator . ' </li>';
                    }
                }

                // If it's a custom post type within a custom taxonomy
                $taxonomy_exists = taxonomy_exists($custom_taxonomy);
                if (empty($term_id) && !empty($custom_taxonomy) && $taxonomy_exists) {

                    $taxonomy_terms = get_the_terms($post->ID, $custom_taxonomy);
                    $cat_id = $taxonomy_terms[0]->term_id;
                    $cat_nicename = $taxonomy_terms[0]->slug;
                    $cat_link = get_term_link($taxonomy_terms[0]->term_id, $custom_taxonomy);
                    $cat_name = $taxonomy_terms[0]->name;

                }

                $paged = get_query_var( 'page' ) ? sprintf(__(' (Page :%s)' ,'pjax-blog'),  get_query_var( 'page' )) : '';

                // Check if the post is in a category
                if (!empty($term_id)) {
                    echo $cat_display;
                    echo '<li class="item-current item-' . $post->ID . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-current bread-' . $post->ID . '" title="' . get_the_title() . $paged . '" href="'. leapin_get_permalink() .'" itemprop="item"><span itemprop="name">' . get_the_title() . $paged . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';

                    // Else if post is in a custom taxonomy
                } else if (!empty($cat_id)) {

                    echo '<li class="item-cat item-cat-' . $cat_id . ' item-cat-' . $cat_nicename . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-cat bread-cat-' . $cat_id . ' bread-cat-' . $cat_nicename . '" href="' . $cat_link . '" title="' . $cat_name . '" itemprop="item"><span itemprop="name">' . $cat_name . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';
                    echo '<li class="separator" role="separator"> ' . $separator . ' </li>';
                    echo '<li class="item-current item-' . $post->ID . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-current bread-' . $post->ID . '" title="' . get_the_title() . $paged . '" href="'. leapin_get_permalink() .'" itemprop="item"><span itemprop="name">' . get_the_title() . $paged . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';

                } else {

                    echo '<li class="item-current item-' . $post->ID . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-current bread-' . $post->ID . '" title="' . get_the_title() . $paged . '" href="'. leapin_get_permalink() .'" itemprop="item"><span itemprop="name">' . get_the_title() . $paged . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';

                }

            } else if (is_category()) {

                // Category page
                $cat_name = single_cat_title('', false);
                $cat_link = get_category_link(leapin_get_yoast_primary_category_id());
                echo '<li class="item-current item-cat" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-current bread-cat" href="' . $cat_link . '" title="' . $cat_name . '" itemprop="item"><span itemprop="name">' . $cat_name . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';

            } else if (is_page()) {

                // Standard page
                if ($post->post_parent) {

                    // If child page, get parents
                    $anc = get_post_ancestors($post->ID);

                    // Get parents in the right order
                    $anc = array_reverse($anc);

                    // Parent page loop
                    if (!isset($parents)) $parents = null;
                    foreach ($anc as $ancestor) {
                        $parents .= '<li class="item-parent item-parent-' . $ancestor . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-parent bread-parent-' . $ancestor . '" href="' . leapin_get_permalink($ancestor) . '" title="' . get_the_title($ancestor) . '" itemprop="item"><span itemprop="name">' . get_the_title($ancestor) . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';
                        $parents .= '<li class="separator separator-' . $ancestor . '" role="separator"> ' . $separator . ' </li>';
                    }

                    // Display parent pages
                    echo $parents;

                    // Current page
                    echo '<li class="item-current item-' . $post->ID . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a href="' . leapin_get_permalink() . '" class="bread-current bread-' . $post->ID . '" title="' . get_the_title() . '" itemprop="item"><span itemprop="name"> ' . get_the_title() . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';

                } else {

                    // Just display current page if not parents
                    echo '<li class="item-current item-' . $post->ID . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a  href="' . leapin_get_permalink() . '" class="bread-current bread-' . $post->ID . '" title="' . get_the_title() . '" itemprop="item"><span itemprop="name"> ' . get_the_title() . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';

                }

            } else if (is_tag()) {

                // Tag page

                // Get tag information
                $term_id = get_query_var('tag_id');
                $taxonomy = 'post_tag';
                $term = get_term_by('id', $term_id, $taxonomy);
                $get_term_id = $term->term_id;
                $get_term_slug = $term->slug;
                $get_term_name = $term->name;
                $get_term_link = get_term_link( $get_term_slug, $taxonomy );
                // Display the tag name
                echo '<li class="item-current item-tag-' . $get_term_id . ' item-tag" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-current bread-tag-' . $get_term_id . ' bread-tag" href="' . $get_term_link . '" itemprop="item"><span itemprop="name">' . $get_term_name . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';

            } elseif (is_day()) {

                // Day archive

                // Year link
                echo '<li class="item-year item-year-' . get_the_time('Y') . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-year bread-year-' . get_the_time('Y') . '" href="' . get_year_link(get_the_time('Y')) . '" title="' . get_the_time('Y') . '" itemprop="item"><span itemprop="name">' . get_the_time('Y') . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';
                echo '<li class="separator separator-' . get_the_time('Y') . '" role="separator"> ' . $separator . ' </li>';

                // Month link
                echo '<li class="item-month item-month-' . get_the_time('m') . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-month bread-month-' . get_the_time('m') . '" href="' . get_month_link(get_the_time('Y'), get_the_time('m')) . '" title="' . get_the_time('M') . '" itemprop="item"><span itemprop="name">' . get_the_time('M') . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';
                echo '<li class="separator separator-' . get_the_time('m') . '" role="separator"> ' . $separator . ' </li>';

                // Day display
                echo '<li class="item-current item-' . get_the_time('j') . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-day bread-' . get_the_time('j') . '" href="' . get_day_link(get_the_time('Y'), get_the_time('m'), get_the_time('j')) . '" title="' . get_the_time('j') . '"  itemprop="item"><span itemprop="name"> ' . get_the_time('jS') . ' ' . get_the_time('M') . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';

            } else if (is_month()) {

                // Month Archive

                // Year link
                echo '<li class="item-year item-year-' . get_the_time('Y') . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-year bread-year-' . get_the_time('Y') . '" href="' . get_year_link(get_the_time('Y')) . '" title="' . get_the_time('Y') . '" itemprop="item"><span itemprop="name">' . get_the_time('Y') . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';
                echo '<li class="separator separator-' . get_the_time('Y') . '" role="separator"> ' . $separator . ' </li>';

                // Month display
                echo '<li class="item-month item-month-' . get_the_time('m') . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-month bread-month-' . get_the_time('m') . '" href="' . get_month_link(get_the_time('Y'), get_the_time('m')) . '" title="' . get_the_time('M') . '" itemprop="item"><span itemprop="name">' . get_the_time('M') . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';

            } else if (is_year()) {

                // Display year archive
                echo '<li class="item-current item-current-' . get_the_time('Y') . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-year bread-year-' . get_the_time('Y') . '" href="' . get_year_link(get_the_time('Y')) . '" title="' . get_the_time('Y') . '" itemprop="item"><span itemprop="name">' . get_the_time('Y') . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';

            } else if (is_author()) {

                // Auhor archive

                // Get the author information
                global $author;
                $userdata = get_userdata($author);

                // Display author name
                echo '<li class="item-current item-current-' . $userdata->user_nicename . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-current bread-current-' . $userdata->user_nicename . '" href="'. $userdata->user_url .'" title="' . $userdata->display_name . '" itemprop="item"><span itemprop="name">' . __('Author', 'pjax-blog') . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';

            } else if (is_search()) {

                // Search results page
                echo '<li class="item-current item-current-' . get_search_query() . '" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a class="bread-current bread-current-' . get_search_query() . '" title="Search results for: ' . get_search_query() . '" itemprop="item" href="'. get_search_query() .'"><span itemprop="name">' . __('Search results for: ', 'pjax-blog') . get_search_query() . '</span></a><meta itemprop="position" content="' . $content_num++ . '"/></li>';

            } elseif (is_404()) {

                // 404 page
                echo '<li class="item-current item-not-found" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><strong class="bread-current bread-current-not-found" title="Not Found" itemprop="item"><span itemprop="name">' . __('Page Not Found','pjax-blog') . '</span></strong><meta itemprop="position" content="' . $content_num++ . '"/></li>';
            }

            echo '</ol>';
            echo '</nav>';

        }

    }

    /**
     * Get multi-level category breadcrumb items
     *
     * @param $term_id
     * @param $content_num
     * @return array
     */
    private static function get_cat_breadcrumbs_link_array($term_id, &$content_num)
    {
        $link_array = array();
        $cat = get_category($term_id);
        $cat_name = $cat->name;
        $cat_link = get_category_link($term_id);
        $link_array[] = '<a class="bread-link bread-cat" href="' . $cat_link . '" title="' . $cat_name . '" itemprop="item"><span itemprop="name">' . $cat_name . '</span></a><meta itemprop="position" content="__content_num__"/>';
        while (1) {
            if (!$cat->parent) break;
            $cat = get_category($cat->parent);
            $cat_name = $cat->name;
            $cat_link = get_category_link($cat->term_id);
            $link_array[] = '<a class="bread-link bread-cat" href="' . $cat_link . '" title="' . $cat_name . '" itemprop="item"><span itemprop="name">' . $cat_name . '</span></a><meta itemprop="position" content="__content_num__"/>';
        }
        $link_array = array_reverse($link_array);
        foreach ($link_array as &$link) {
            $link = str_replace('__content_num__', $content_num++, $link);
        }
        return $link_array;
    }

}
