<?php
/**
 * Other Setting
 *
 * @author LeapIn Corp.
 * @since 1.0.0
 */
$panel = 'leapin_settings';
$section = 'leapin_other_section';
LEAPIN_IDs::initPriority();

$wp_customize->add_section($section, array(
    'title' => __('Other', 'pjax-blog'),
    'panel' => $panel,
    'description' => __('Select other settings as you like.', 'pjax-blog'),
    'priority' => 999,
    'capability' => 'manage_options',
));

/**
 * Browser Address Bar Color
 */
$wp_customize->add_setting($setting_id = LEAPIN_IDs::$leapin_other_address_bar_color, array(
    'type' => 'theme_mod', // or 'option'
    'capability' => 'manage_options',
    'default' => '',
    'transport' => LEAPIN_IDs::$refresh,
    'sanitize_callback' => 'leapin_sanitize_rgba_color'
));
$wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, LEAPIN_IDs::$leapin_other_address_bar_color, array(
    'label' => __('Browser Address Bar Color', 'pjax-blog'),
    'section' => $section,
    'description' => __('Change Address Bar Color of Mobile Browser if you like.', 'pjax-blog'),
    'settings' => LEAPIN_IDs::$leapin_other_address_bar_color,
    'priority' => LEAPIN_IDs::getPriority()
)));

/**
 * Loading Three Dots Color
 */
$wp_customize->add_setting($setting_id = LEAPIN_IDs::$leapin_other_loading_dots_color, array(
    'type' => 'theme_mod', // or 'option'
    'capability' => 'manage_options',
    'default' => '',
    'transport' => LEAPIN_IDs::$postMessage,
    'sanitize_callback' => 'leapin_sanitize_rgba_color'
));
$wp_customize->add_control(new LEAPIN_Customize_Alpha_Color_Control($wp_customize, LEAPIN_IDs::$leapin_other_loading_dots_color, array(
    'label' => __('Loading Three Dots Color', 'pjax-blog'),
    'section' => $section,
    'settings' => LEAPIN_IDs::$leapin_other_loading_dots_color,
    'show_opacity' => true,
    'priority' => LEAPIN_IDs::getPriority()
)));
